from network import *

MU = .5

class RecurrentNetwork(Network):

    def __init__(self, name, layers,
                 # Source of the recurrent input layer, either 'o(utput)' or 'h(idden)'
                 source = 'h',
                 mu = MU,
                 teacher_forcing = False):
        self.source = 'h' if source[0] == 'h' else 'o'
        self.mu = mu
        self.teacher_forcing = teacher_forcing
        Network.__init__(self, name, layers)

    def initialize(self):
        '''Increase input Layer size and assign weights.'''
        self.recurrent_layer = self.layers[-1] if self.source == 'o' else self.layers[1]
        self.layers[0].size += self.recurrent_layer.size
        Network.initialize(self)

    def pre_stuff(self, target = []):
        if self.source == 'o':
            recur_source = target if self.teacher_forcing else self.recurrent_layer.activations
            for u in range(self.recurrent_layer.size):
                # Decay the context unit
                self.layers[0].activations[-(u + 1)] *= self.mu
                self.layers[0].activations[-(u + 1)] += (1 - self.mu) * recur_source[-(u + 1)]
        else:
            for u in range(self.recurrent_layer.size):
                self.layers[0].activations[-(u + 1)] = self.recurrent_layer.activations[-(u + 1)]

        
